#include <termios.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include "float.cc"

#include <readline/readline.h>
#include <readline/history.h>

// extern void mains();

#ifndef O_BINARY
#define O_BINARY 0
#endif


#ifndef S_IREAD 
#define S_IREAD O_RDONLY
#endif
#ifndef  S_IWRITE
#define S_IWRITE O_WRONLY
#endif


char * ARGV1;
//int AAAA=444;

long long RWGet()
{  return O_RDWR ;
}
long long ROGet()
{  return O_RDONLY ;
 }
long long WOGet()
{  return O_WRONLY ;
}

long long SEEK_SETGet() { return SEEK_SET ; }
long long O_CREATGet() { return O_CREAT ; }
long long O_TRUNCGet() { return O_TRUNC ; }

//extern long long add(long long aa,long long bb);
extern void amain(); 
extern void TST(); 
/*
long long add(long long aa,long long bb)
{ return aa+bb;
} */

void HPOINT(long long x)
{   printf("%x ",x);
}

long long	mtell(long long _fd)
{ return lseek(_fd, (off_t) 0, SEEK_CUR); }

long long	rmlseek(long long _fd, long long off1)
{ return lseek(_fd, (off_t) off1, SEEK_SET); }

long long	mlseek(long long _fd, long long off1, long long mode)
{ return lseek(_fd, (off_t) off1, mode); }


long long LACCEPT(char *p,long long n)
{ register char *q;
  q = fgets (p, n, stdin);
  q = strrchr (p, '\n');
  if (q) *q = '\0';
  return strlen (p);
}

char* LARGV1() {return ARGV1;}

void LZTYPE(char *p)
{ printf("%s\n",p);
}

void LBYE()
{  exit(0); }


/*----------------------------------------------------------*/
// from kforth-1.2.10 

struct termios tios0;
char key_query_char = 0;

void save_term ()
{
    tcgetattr(0, &tios0);
}

void restore_term ()
{
    tcsetattr(0, TCSANOW, &tios0);
}

void echo_off ()
{
  struct termios t;
  tcgetattr(0, &t);
  t.c_lflag &= ~ECHO;
  tcsetattr(0, TCSANOW, &t);
}

void echo_on ()
{
  struct termios t;
  tcgetattr(0, &t);
  t.c_lflag |= ECHO;
  tcsetattr(0, TCSANOW, &t);
}
/*----------------------------------------------------------*/




long long C_KEY ()
{
  /* stack: ( -- n | wait for keypress and return key code ) */

  char ch;
  int n;
  struct termios t1, t2;

  if (key_query_char)
    {
      ch = key_query_char;
      key_query_char = 0;
    }
  else
    {
      tcgetattr(0, &t1);
      t2 = t1;
      t2.c_lflag &= ~ICANON;
      t2.c_lflag &= ~ECHO;
//      t2.c_lflag &= ~ISIG;
      t2.c_lflag |= ISIG;
      t2.c_cc[VMIN] = 1;
      t2.c_cc[VTIME] = 0;
      tcsetattr(0, TCSANOW, &t2);

//      do {
	n = read(0, &ch, 1);
//      } while (n != 1);

      tcsetattr(0, TCSANOW, &t1);
    }
 
  return ch;
}
/*----------------------------------------------------------*/

long long C_KEYQUERY ()
{
  /* stack: ( a -- b | return true if a key is available ) */

  char ch = 0;
  int chq;
  struct termios t1, t2;

  if (key_query_char)  return -1;

      tcgetattr(0, &t1);
      t2 = t1;
      t2.c_lflag &= ~ICANON;
      t2.c_lflag &= ~ECHO;
      t2.c_cc[VMIN] = 0;
      t2.c_cc[VTIME] = 0;
      tcsetattr(0, TCSANOW, &t2);

      chq = read(0, &ch, 1) ? -1 : 0;
      if (ch) key_query_char = ch;  
      tcsetattr(0, TCSANOW, &t1);

  return chq;
}      
/*----------------------------------------------------------*/

long long C_ACCEPT0 (char *cp, long long n1 )
{
  /* stack: ( a n1 -- n2 | wait for n characters to be received ) */

  char ch,  *cpstart, *bksp = "\010 \010";
  int n2, nr;
  struct termios t1, t2;

  cpstart = cp;

  tcgetattr(0, &t1);
  t2 = t1;
  t2.c_lflag &= ~ICANON;
  t2.c_lflag &= ~ECHO;
  t2.c_lflag &= PENDIN;

  t2.c_cc[VMIN] = 1;
  t2.c_cc[VTIME] = 0;
  tcsetattr(0, TCSANOW, &t2);


  n2 = 0;
  while (n2 < n1)
    {
      nr = read (0, cp, 1);
      if (nr == 1) 
	{
	  if (*cp == 10) 
	    break;
	  else if (*cp == 127)
	  {
	    write (0, bksp, 3);
	    --cp; --n2;
	    if (cp < cpstart) cp = cpstart;
	    if (n2 < 0) n2 = 0;
	  }
	  else
	  {
	    write (0, cp, 1);
	    ++n2; ++cp;
	  }
	}
    }

  tcsetattr(0, TCSANOW, &t1);
  return n2;
}

long long L_ACCEPT (char *cp, long long n1 )
{  struct termios t1, t2;
  int n2;
  tcgetattr(0, &t1);
  t2 = t1;
  t2.c_lflag |= ICANON;
  t2.c_lflag |= ECHO;
  t2.c_lflag |= PENDIN;

  t2.c_cc[VMIN] = 1;
  t2.c_cc[VTIME] = 0;
  tcsetattr(0, TCSANOW, &t2);
   n2 = read (0, cp, n1);
  tcsetattr(0, TCSANOW, &t1);
  return n2;
}

/* A static variable for holding the line. */
static char *line_read = (char *)NULL;
// http://oco.org.ua/sp-forth-%D0%B2-linux
/* Read a string, and return a pointer to it.  Returns NULL on EOF. */
char *
rl_gets ()
{
  /* If the buffer has already been allocated, return the memory
     to the free pool. */
  if (line_read)
    {
      free (line_read);
      line_read = (char *)NULL;
    }

  /* Get a line from the user. */
  line_read = readline ("");

  /* If the line has any text in it, save it on the history. */
  if (line_read && *line_read)
    add_history (line_read);

  return (line_read);
}

long long CC_ACCEPT (char *cp, long long n1 )
{
	char * zzz;
	int res=0;
        zzz=rl_gets();
	write_history("rlhistory.cfg");
        while( (*zzz!=0) & (n1!=0) )
        { cp[res]=*zzz; res++; zzz++;n1--; }
	cp[res]='\n';
	return res;
}

static long long ASCREEN;
static struct {char lines, cols, x, y;} scrn;

long long wherexy(void) {								/* 19 */
    lseek(ASCREEN, 0, SEEK_SET); read(ASCREEN, &scrn, 4);
    return ((scrn.x << 16) | (scrn.y & 0xFFFF)); }

long long zzzz()
{ return 0x5555777733331111l;
}

long long LOPEN(const char *pathname, long flags)
{ return open(pathname, flags,S_IREAD | S_IWRITE);
}

main(int argc,char **argv)
{  char kk;
   char ccc[99];
   int rr;
   ARGV1=argv[1];
   FP=&FPBuf[FPBufSize-2];
  read_history("rlhistory.cfg");
    open("uuuuu",O_CREAT|O_WRONLY,S_IRUSR | S_IWUSR );
    LOPEN("TTTTTT",O_CREAT|O_WRONLY);
  amain();
  
  return 0;
}


